import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
const _excluded = ["value", "label", "attachment", "readOnly", "onChange", "styles"];
var _dec, _dec2, _dec3, _dec4, _class, _CodeEditor;
/*
 * The MIT License (MIT)
 *
 * Copyright (c) 2015 - present Instructure, Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import { Component, createRef, lazy, Suspense } from 'react';
import { testable } from '@instructure/ui-testable';
import { ScreenReaderContent } from '@instructure/ui-a11y-content';
import { deprecated, passthroughProps, withDeterministicId } from '@instructure/ui-react-utils';
import { withStyle, Global } from '@instructure/emotion';
import generateStyle from './styles';
import generateComponentTheme from './theme';
import { propTypes, allowedProps } from './props';
import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
//@ts-expect-error: different types between node and client version
const CodeMirrorWrapper = /*#__PURE__*/lazy(() => {
  const isServerRendered = typeof navigator === 'undefined' || typeof global !== 'undefined' && global['PREVENT_CODEMIRROR_RENDER'] === true;
  if (isServerRendered) {
    return import('../CodeMirrorWrapper/index.node');
  }
  return import('../CodeMirrorWrapper');
});

/**
---
category: components/deprecated
---
**/
let CodeEditor = (_dec = withDeterministicId(), _dec2 = withStyle(generateStyle, generateComponentTheme), _dec3 = testable(), _dec4 = deprecated('[TBD]', null, 'This component is deprecated and will be removed in a later version. Use <SourceCodeEditor /> instead, which is the wrapper for the newer version of the CodeMirror code editor.'), _dec(_class = _dec2(_class = _dec3(_class = _dec4(_class = (_CodeEditor = class CodeEditor extends Component {
  constructor(props) {
    super(props);
    this._id = void 0;
    this.codeMirror = void 0;
    this.ref = void 0;
    this.editor = void 0;
    this._id = props.deterministicId();
    this.ref = /*#__PURE__*/createRef();
    this.editor = /*#__PURE__*/createRef();
    this.codeMirror = /*#__PURE__*/createRef();
  }
  componentDidMount() {
    var _this$props$makeStyle, _this$props;
    (_this$props$makeStyle = (_this$props = this.props).makeStyles) === null || _this$props$makeStyle === void 0 ? void 0 : _this$props$makeStyle.call(_this$props);
  }
  componentDidUpdate() {
    var _this$props$makeStyle2, _this$props2;
    (_this$props$makeStyle2 = (_this$props2 = this.props).makeStyles) === null || _this$props$makeStyle2 === void 0 ? void 0 : _this$props$makeStyle2.call(_this$props2);
  }
  focus() {
    if (this.codeMirror) {
      ;
      this.codeMirror.focus();
    }
  }
  get mode() {
    const language = this.props.language;
    if (language === 'json' || language === 'js') {
      return 'jsx';
    } else if (language === 'sh') {
      return 'shell';
    } else if (language === 'html') {
      return 'htmlmixed';
    } else if (language === 'yml') {
      return 'yaml';
    } else {
      return language;
    }
  }
  get options() {
    return {
      ...this.props.options,
      readOnly: this.props.readOnly,
      mode: this.mode,
      extraKeys: this.props.readOnly ? {
        Tab: false,
        'Shift-Tab': false
      } : {}
    };
  }
  render() {
    const _this$props3 = this.props,
      value = _this$props3.value,
      label = _this$props3.label,
      attachment = _this$props3.attachment,
      readOnly = _this$props3.readOnly,
      onChange = _this$props3.onChange,
      styles = _this$props3.styles,
      rest = _objectWithoutProperties(_this$props3, _excluded);
    return _jsx("div", {
      css: styles === null || styles === void 0 ? void 0 : styles.codeEditor,
      ref: this.ref,
      children: _jsxs(Suspense, {
        children: [_jsx(Global, {
          styles: styles === null || styles === void 0 ? void 0 : styles.globalStyles
        }), _jsxs("label", {
          htmlFor: this._id,
          children: [_jsx(ScreenReaderContent, {
            children: label
          }), _jsx(CodeMirrorWrapper, {
            ...passthroughProps(rest),
            id: this._id,
            options: this.options,
            value: value,
            onBeforeChange: (_editor, _data, value) => {
              onChange === null || onChange === void 0 ? void 0 : onChange(value);
            }
            // @ts-expect-error we should delete this..
            ,
            ref: this.codeMirror,
            editorDidMount: e => {
              // @ts-expect-error read only property
              this.editor.current = e;
            },
            editorWillUnmount: () => {
              // @ts-expect-error hack:
              this.editor.current.display.wrapper.remove();
              if (this.codeMirror.current) {
                // @ts-expect-error hack:
                this.codeMirror.current.hydrated = false;
              }
            }
          })]
        })]
      })
    });
  }
}, _CodeEditor.displayName = "CodeEditor", _CodeEditor.componentId = 'CodeEditor', _CodeEditor.propTypes = propTypes, _CodeEditor.allowedProps = allowedProps, _CodeEditor.defaultProps = {
  language: 'jsx',
  readOnly: false,
  options: {
    styleActiveLine: true
  }
}, _CodeEditor)) || _class) || _class) || _class) || _class);
export default CodeEditor;
export { CodeEditor };