"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.CodeEditor = void 0;
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _interopRequireWildcard2 = _interopRequireDefault(require("@babel/runtime/helpers/interopRequireWildcard"));
var _react = require("react");
var _testable = require("@instructure/ui-testable/lib/testable.js");
var _ScreenReaderContent = require("@instructure/ui-a11y-content/lib/ScreenReaderContent");
var _deprecated = require("@instructure/ui-react-utils/lib/deprecated.js");
var _passthroughProps = require("@instructure/ui-react-utils/lib/passthroughProps.js");
var _withDeterministicId = require("@instructure/ui-react-utils/lib/DeterministicIdContext/withDeterministicId.js");
var _emotion = require("@instructure/emotion");
var _styles = _interopRequireDefault(require("./styles"));
var _theme = _interopRequireDefault(require("./theme"));
var _props = require("./props");
var _jsxRuntime = require("@emotion/react/jsx-runtime");
const _excluded = ["value", "label", "attachment", "readOnly", "onChange", "styles"];
var _dec, _dec2, _dec3, _dec4, _class, _CodeEditor;
/*
 * The MIT License (MIT)
 *
 * Copyright (c) 2015 - present Instructure, Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
//@ts-expect-error: different types between node and client version
const CodeMirrorWrapper = /*#__PURE__*/(0, _react.lazy)(() => {
  const isServerRendered = typeof navigator === 'undefined' || typeof global !== 'undefined' && global['PREVENT_CODEMIRROR_RENDER'] === true;
  if (isServerRendered) {
    return Promise.resolve().then(() => (0, _interopRequireWildcard2.default)(require('../CodeMirrorWrapper/index.node')));
  }
  return Promise.resolve().then(() => (0, _interopRequireWildcard2.default)(require('../CodeMirrorWrapper')));
});

/**
---
category: components/deprecated
---
**/
let CodeEditor = exports.CodeEditor = (_dec = (0, _withDeterministicId.withDeterministicId)(), _dec2 = (0, _emotion.withStyle)(_styles.default, _theme.default), _dec3 = (0, _testable.testable)(), _dec4 = (0, _deprecated.deprecated)('[TBD]', null, 'This component is deprecated and will be removed in a later version. Use <SourceCodeEditor /> instead, which is the wrapper for the newer version of the CodeMirror code editor.'), _dec(_class = _dec2(_class = _dec3(_class = _dec4(_class = (_CodeEditor = class CodeEditor extends _react.Component {
  constructor(props) {
    super(props);
    this._id = void 0;
    this.codeMirror = void 0;
    this.ref = void 0;
    this.editor = void 0;
    this._id = props.deterministicId();
    this.ref = /*#__PURE__*/(0, _react.createRef)();
    this.editor = /*#__PURE__*/(0, _react.createRef)();
    this.codeMirror = /*#__PURE__*/(0, _react.createRef)();
  }
  componentDidMount() {
    var _this$props$makeStyle, _this$props;
    (_this$props$makeStyle = (_this$props = this.props).makeStyles) === null || _this$props$makeStyle === void 0 ? void 0 : _this$props$makeStyle.call(_this$props);
  }
  componentDidUpdate() {
    var _this$props$makeStyle2, _this$props2;
    (_this$props$makeStyle2 = (_this$props2 = this.props).makeStyles) === null || _this$props$makeStyle2 === void 0 ? void 0 : _this$props$makeStyle2.call(_this$props2);
  }
  focus() {
    if (this.codeMirror) {
      ;
      this.codeMirror.focus();
    }
  }
  get mode() {
    const language = this.props.language;
    if (language === 'json' || language === 'js') {
      return 'jsx';
    } else if (language === 'sh') {
      return 'shell';
    } else if (language === 'html') {
      return 'htmlmixed';
    } else if (language === 'yml') {
      return 'yaml';
    } else {
      return language;
    }
  }
  get options() {
    return {
      ...this.props.options,
      readOnly: this.props.readOnly,
      mode: this.mode,
      extraKeys: this.props.readOnly ? {
        Tab: false,
        'Shift-Tab': false
      } : {}
    };
  }
  render() {
    const _this$props3 = this.props,
      value = _this$props3.value,
      label = _this$props3.label,
      attachment = _this$props3.attachment,
      readOnly = _this$props3.readOnly,
      onChange = _this$props3.onChange,
      styles = _this$props3.styles,
      rest = (0, _objectWithoutProperties2.default)(_this$props3, _excluded);
    return (0, _jsxRuntime.jsx)("div", {
      css: styles === null || styles === void 0 ? void 0 : styles.codeEditor,
      ref: this.ref,
      children: (0, _jsxRuntime.jsxs)(_react.Suspense, {
        children: [(0, _jsxRuntime.jsx)(_emotion.Global, {
          styles: styles === null || styles === void 0 ? void 0 : styles.globalStyles
        }), (0, _jsxRuntime.jsxs)("label", {
          htmlFor: this._id,
          children: [(0, _jsxRuntime.jsx)(_ScreenReaderContent.ScreenReaderContent, {
            children: label
          }), (0, _jsxRuntime.jsx)(CodeMirrorWrapper, {
            ...(0, _passthroughProps.passthroughProps)(rest),
            id: this._id,
            options: this.options,
            value: value,
            onBeforeChange: (_editor, _data, value) => {
              onChange === null || onChange === void 0 ? void 0 : onChange(value);
            }
            // @ts-expect-error we should delete this..
            ,
            ref: this.codeMirror,
            editorDidMount: e => {
              // @ts-expect-error read only property
              this.editor.current = e;
            },
            editorWillUnmount: () => {
              // @ts-expect-error hack:
              this.editor.current.display.wrapper.remove();
              if (this.codeMirror.current) {
                // @ts-expect-error hack:
                this.codeMirror.current.hydrated = false;
              }
            }
          })]
        })]
      })
    });
  }
}, _CodeEditor.displayName = "CodeEditor", _CodeEditor.componentId = 'CodeEditor', _CodeEditor.propTypes = _props.propTypes, _CodeEditor.allowedProps = _props.allowedProps, _CodeEditor.defaultProps = {
  language: 'jsx',
  readOnly: false,
  options: {
    styleActiveLine: true
  }
}, _CodeEditor)) || _class) || _class) || _class) || _class);
var _default = exports.default = CodeEditor;