import { Component } from 'react';
import type { CodeEditorProps } from './props';
import type CodeMirror from 'codemirror';
import type { EditorConfiguration } from 'codemirror';
declare global {
    var PREVENT_CODEMIRROR_RENDER: boolean;
}
/**
---
category: components/deprecated
---
**/
declare class CodeEditor extends Component<CodeEditorProps> {
    static readonly componentId = "CodeEditor";
    static propTypes: import("@instructure/shared-types").PropValidators<keyof {
        label: string;
        language?: "sh" | "js" | "json" | "javascript" | "jsx" | "shell" | "css" | "html" | "markdown" | "yaml" | "yml" | "bash";
        readOnly?: boolean | "nocursor";
        onChange?: (value: string) => void;
        options?: EditorConfiguration;
        attachment?: "bottom" | "top";
        value?: string;
    }>;
    static allowedProps: readonly (keyof {
        label: string;
        language?: "sh" | "js" | "json" | "javascript" | "jsx" | "shell" | "css" | "html" | "markdown" | "yaml" | "yml" | "bash";
        readOnly?: boolean | "nocursor";
        onChange?: (value: string) => void;
        options?: EditorConfiguration;
        attachment?: "bottom" | "top";
        value?: string;
    })[];
    static defaultProps: {
        language: string;
        readOnly: boolean;
        options: {
            styleActiveLine: boolean;
        };
    };
    private readonly _id;
    private codeMirror;
    ref: import("react").RefObject<HTMLDivElement>;
    editor: import("react").RefObject<CodeMirror.Editor>;
    constructor(props: CodeEditorProps);
    componentDidMount(): void;
    componentDidUpdate(): void;
    focus(): void;
    get mode(): "javascript" | "jsx" | "shell" | "css" | "markdown" | "yaml" | "bash" | "htmlmixed" | undefined;
    get options(): EditorConfiguration;
    render(): import("@emotion/react/jsx-runtime").JSX.Element;
}
export default CodeEditor;
export { CodeEditor };
//# sourceMappingURL=index.d.ts.map